      SUBROUTINE ANITO2(ALL,NR,NSOLMX,WMOL,DOBS,PRNTMR,PRNTLN,NTST,
     1  NRRUN)
C-----------------------------------------------------------------------
C  THIS IS THE SECOND HALF OF THE MAIN PROGRAM.
C  THIS PART IS CALLED WHEN THE ZONES HAVE BEEN ESTABLISHED AND
C  COMBINATIONS HAVE BEEN MADE THAT COULD RESULT IN CORRECT LATTICES.
C-----------------------------------------------------------------------
C  .... CHANGED:  210585    ADDED SUMM OUTPUT+ /HISYM /
C  .... CHANGED:  111085    REPLACED OUTPUT FOR /HISYM/ BY *SYMPRT*
C  .... CHANGED:  271185    ADDED SRTSYM (SORTS HIGH-SYM LATTICES)
C  .... CHANGED:  080486    ADDED SOME 'NSUMM' OUTPUT
C  LAST CHANGED:  150986    REMOVED POSS. INFINITE LOOP 2000-2100
C-----------------------------------------------------------------------
      DIMENSION OLD(6)
      INTEGER  H
C-----------------------------------------------------------------------
C
C        ****************************
C        * ATTENTION   H = INTEGER  *
C        ****************************
C
C-----------------------------------------------------------------------
      LOGICAL SELF,ENL,TEST,ALL
      CHARACTER*1 BRAVTP(6)
      CHARACTER NAME*80,CARD*80,SNAME*70,INTSY*2
      COMMON /LINES / IDOC,INP,IOUT ,MAX,OBS(40),CEL(10)
      COMMON /CHARCM/ NAME,CARD,INTSY(50)
      COMMON /PARMS / TOL2,TOL3,WAVEL,FMINEQ,FMINIM,SELF,ENL,TEST,LIST,
     *                NSYST(3),OBSMT(40),OBSPT(40),TWTHET(40),TOLG
      COMMON /TEMRES/ LINCO,NQ2,NINDEX,INDEX(40),ROSTER(150,12)
      COMMON /CONSTS/ NSUMM,RAD,TWORAD,RRAD,HLFLAM,WAVSQR,STORE(200,9)
      COMMON /THETAS/ ZERTOT,OBSTET(40),SHFTET(40),TETPT(40),TETMT(40)
      COMMON /HISYM / ISOL,SYMCON(12,6),NMATCH(45)
      DATA  BRAVTP(1)/'A'/,BRAVTP(2)/'B'/,BRAVTP(3)/'C'/
     *   ,  BRAVTP(4)/'I'/,BRAVTP(5)/'F'/,BRAVTP(6)/'P'/
      IF (ALL) THEN
         N4=NR
         GO TO 2000
      END IF
C  ---------------------------------------------------------------------
C  ALL IS  ABUSED HERE TO EXECUTE THE JUMP FROM AAITO1 TO 2000
C  WHEN COMPLETE LATTICES HAVE BEEN GIVEN AS INPUT.
C  ---------------------------------------------------------------------
      CALL NTEST(NTST,5)
      CALL THREED
C  ---------------------------------------------------------------------
C  THE PROCEDURE THREED TRIES TO FIND THE ANGLE BETWEEN TWO
C  INTERSECTING ZONES, DETERMINED BY THE LAST SECTION.(REAR),
C  THE POSSIBLE  LATTICES WERE ON  EVERY FOURTH POSITION IN ROSTER.
C  IF MORE THAN ONE VALUE OF D IS FOUND, THE ADDITIONAL POSSIBLE
C  LATTICES ARE STORED AFTER THE FIRST. A MAXIMUM OF FOUR DIFFERENT
C  VALUES OF D CAN THUS BE ACCOMODATED.  EMPTY POSITIONS ARE MARKED BY
C  A ZERO IN POSITION 7.
C-----------------------------------------------------------------------
      WRITE(IOUT ,9960) NAME
      N4=LINCO+4
      N=0
      DO 1910 I=1,N4
      IF (ROSTER(I,7).LT.1.)GO TO  1910
      N=N+1
      DO 1905 J=1,8
 1905 ROSTER(N,J)=ROSTER(I,J)
      WRITE(IOUT ,9937)  N,(ROSTER(N,J),J=1,8)
 1910 CONTINUE
      CALL TIMER(5)
      N4=N
C  ---------------------------------------------------------------------
C--THE LATTICES FOUND WILL BE PUT INTO A STANDARD SHAPE.(NORMALISED)
C  ---------------------------------------------------------------------
      CALL NTEST(NTST,6)
      IF (N4 .EQ. 0 ) THEN
         WRITE(NSUMM,9924)
         WRITE(IOUT ,9925)
         RETURN
      END IF
C
C  ROSTER(N,1..6) CONTAIN THE LATTICE CONSTANTS, 7 GIVES THE NUMBER
C  OF HITS AND 8 CONTAINS THE PEDIGREE.
C
      DO 1990 J=1,N4
      DO 1930 I=1,8
 1930 CEL(I)=ROSTER(J,I)
      CALL NORM3
      DO 1940 I=1,8
 1940 ROSTER(J,I)=CEL(I)
      IF (J .EQ. 1) GO TO 1990
      MJ=J-1
C  ---------------------------------------------------------------------
C  FIRST WE MARK 'EQUAL' LATTICES .
C  ---------------------------------------------------------------------
      DO 1980 K=1,MJ
      U=0.0
      DO 1950 I=1,6
 1950 U=U+ABS(ROSTER(K,I)-ROSTER(J,I))
      IF (U .GT. FMINEQ) GO TO 1990
C  ---------------------------------------------------------------------
C  IF TWO LATTICES ARE EQUAL,WE SET ROSTER(N,7)=0 AND GIVE THE
C  PEDIGREE OF THE OTHER IN ROSTER(N,9)
C  ---------------------------------------------------------------------
      IF (ROSTER(K,7) .LT. ROSTER(J,7) ) THEN
         ROSTER(K,7)=0.
         ROSTER(K,9)=ROSTER(J,8)
      ELSE
         ROSTER(J,7)=0.
         ROSTER(J,9)=ROSTER(K,8)
      END IF
 1980 CONTINUE
 1990 CONTINUE
 2000 CALL TIMER(6)
C-----------------------------------------------------------------------
C  THE LATTICES ARE NOW NORMALIZED,AND THE PATHOLOGICAL CASES HAVE
C  BEEN MARKED. THE NEXT STEP IS TO TRY AND REFINE THE LATTICES THAT
C  ARE LEFT.
C  ---------------------------------------------------------------------
      ALL=.FALSE.
      CALL NTEST(NTST,7)
      DO 2100 J=1,N4
      IF (ROSTER(J,1) .LT. FMINEQ) GO TO 2100
      IF (ROSTER(J,7) .LT. FMINEQ) GO TO 2100
      IF (TEST) WRITE(IOUT ,9909) J
C  COUNT THE NUMBER OF TIMES THAT THIS LATTICE GOES THROUGH REFPAR AND
C  NORM3 (CHANGE 150986)
      NRNORM=0
      DO 2030 I=1,10
 2030 CEL(I)=ROSTER(J,I)
      CEL(10)=CEL(8)
 2040 CEL(7)=0.
      ZERTOT=0.
C-----------------------------------------------------------------------
C  A FIRST ROUND OF LEAST SQUARES (IN REFPAR) WILL NOW BE RUN.
C-----------------------------------------------------------------------
      CALL REFPAR(NSOL,ALL)
      IF (CEL(7) .LT. PRNTLN) GO TO 2080
      IF (CEL(8) .LT. PRNTMR) GO TO 2080
      DO 2060 I=1,6
 2060 OLD(I)=CEL(I)
      CALL NORM3
      NRNORM=NRNORM+1
      IF (CEL(1) .LT. FMINIM) GO TO 2080
      U=0.
      DO 2070 I=1,6
 2070 U=U+ABS(CEL(I)-OLD(I))
      IF (NRNORM .GT. 3) THEN
         WRITE(IOUT ,9905) J, (CEL(I),I=1,10)
         WRITE(NSUMM,9905) J, (CEL(I),I=1,10)
         GO TO 2080
      END IF
      IF (U .GT. 0.1) GO TO 2040
C  IF NORM3 CHANGES THE RECIPROCAL CELL, WE HAVE TO DETERMINE
C  THE BRAVAIS TYPE AGAIN. (AND REFINE THE NEW PARAMETERS)
C
 2080 DO 2090 K=1,10
 2090 ROSTER(J,K)=CEL(K)
      ROSTER(J,11)=ZERTOT
 2100 CONTINUE
C-----------------------------------------------------------------------
C  PRINT THE FATE OF THE DISCARDED LATTICES AND
C  COLLECT THE GOOD ONES.
C-----------------------------------------------------------------------
      NR=0
      IF (ENL) WRITE(IOUT ,9936) NAME
      DO 2200 J=1,N4
      IF (ROSTER(J,1) .GT. FMINEQ) GO TO 2110
      IF (ENL) WRITE(IOUT ,9910) J,(ROSTER(J,I),I=1,6),ROSTER(J,8)
      GO TO 2200
 2110 IF (ROSTER(J,7) .GT. FMINEQ) GO TO 2120
      IF (ENL) WRITE(IOUT ,9911) J,(ROSTER(J,I),I=1,9)
      GO TO 2200
 2120 IF (ROSTER(J,7) .GT. PRNTLN) GO TO 2150
      IF (ENL) WRITE(IOUT ,9912) J,(ROSTER(J,I),I=1,10)
      GO TO 2200
 2150 IF (ROSTER(J,8) .GT. PRNTMR) GO TO 2160
      IF (ENL) WRITE(IOUT ,9913) J,(ROSTER(J,I),I=1,10)
      GO TO 2200
C  FINALLY,THE LATTICE IS ACCEPTED
 2160 NR=NR+1
      DO 2180 K=1,12
 2180 ROSTER(NR,K)=ROSTER(J,K)
      IF (ENL) WRITE(IOUT ,9914) J,(ROSTER(NR,I),I=1,10)
 2200 CONTINUE
      IF (ENL) THEN
         WRITE(IOUT ,9915)
         WRITE(IOUT ,9916)
      END IF
      CALL TIMER(7)
C-----------------------------------------------------------------------
C  A DOUBLE SORT WILL NOW BE CARRIED OUT, FIRST ON THE NUMBER OF
C  LINES INDEXED(POS. 7)   AND SECONDLY ON THE FIGURE OF MERIT (POS. 8)
C  OF THE LATTICES.
C-----------------------------------------------------------------------
      IF (NR .EQ. 0) THEN
         WRITE(NSUMM,9924)
         WRITE(IOUT ,9990)
         RETURN
      END IF
      WRITE(IOUT ,9950) NAME
      WRITE(IOUT ,9951)
      SNAME=NAME
      WRITE(NSUMM,9980) SNAME
      JJ=100
      DO 3050 L=1,NR
      K=0
      AA=0.
      DO 3030 H=L,NR
      M= ROSTER(H,7)+0.5
      B= ROSTER(H,8)
      IF (M-K) 3030,3020,3010
 3010 K=M
      I=H
      AA=B
      GO TO 3030
 3020 IF(B.LE.AA) GO TO 3030
      AA=B
      I=H
 3030 CONTINUE
      IF (K.GE.JJ) GO TO 3040
      WRITE(IOUT ,9952)
      WRITE(NSUMM,9952)
      JJ=K
 3040 DO 3045 N=1,12
      A= ROSTER(I,N)
      ROSTER(I,N)= ROSTER(L,N)
      ROSTER(L,N)=A
      IF (N .LE. 10) CEL(N)=A
 3045 CONTINUE
C  CALCULATE VOLUME OF UNIT CEL AND PRINT
      CALL UNTCEL(WMOL,DOBS,VOL,0)
      KKK=NINT(ROSTER(L,9))
      TET=TWORAD*ROSTER(L,11)
      WRITE(IOUT ,9953) (ROSTER(L,N),N=1,8),BRAVTP(KKK),
     * ROSTER(L,10), VOL,TET
      WRITE(NSUMM,9983) (ROSTER(L,N),N=1,8),BRAVTP(KKK)
 3050 CONTINUE
C-----------------------------------------------------------------------
C--END OF SORT AND PRINT.
C-----------------------------------------------------------------------
      WRITE(IOUT ,9963)
      CALL NTEST(NTST,8)
C-----------------------------------------------------------------------
C  WE NOW PRINT OUT THE BEST *NSOLMX* SOLUTIONS WITH AN INDEXED LIST
C  OF THE FIRST TWENTY LINES.  IF YOU HAVE SET  'TEST' THEN YOU ALSO
C  GET  THE Q-VALUES PRINTED OUT AS A  LATTICE.
C-----------------------------------------------------------------------
      IF (NR .LT. NSOLMX) NSOLMX=NR
      WRITE(IOUT ,9964) NSOLMX
      N=0
      MIN=-1
      SELF=.TRUE.
      DO 3060 I=1,3
 3060 IF (NSYST(I) .NE.0) N=I
      IF (N .NE. 0) SELF=.FALSE.
      IF (SELF) GO TO 3090
C  SELF=.FALSE. IF WE WANT TO FORCE A CERTAIN CRYSTAL SYSTEM.
      N=0
      M=0
      DO 3070 K=1,3
      IF (NSYST(K) .EQ. 1) N=N+1
      IF (NSYST(K) .EQ.(-1) ) M=M+1
 3070 CONTINUE
      IF (N .GT. 0) WRITE(IOUT ,9965)
      IF (M .GT. 0) WRITE(IOUT ,9966)
      IF (N .GT. 0) MIN=1
      IF (M .GT. 0) MIN=0
      DO 3080 M=1,MAX
      DIF=OBS(M)-OBSMT(M)
      OBSMT(M)=OBSMT(M)-DIF
 3080 OBSPT(M)=OBSPT(M)+DIF
C  THE TOLERANCES HAVE BEEN DOUBLED WHEN YOU WANT TO  FORCE A CERTAIN
C  CRYSTAL SYSTEM.
      WRITE(IOUT ,9967)
 3090 NSOL=0
      DO 3200 I=1,NR
      IF (SELF) GO TO 3120
      NORDE=1
      DO 3110 J=4,6
 3110 IF (ABS(ROSTER(I,J)) .GT. FMINEQ) NORDE=NORDE+1
      IF (NORDE .EQ. 4) NORDE=3
      IF (NSYST(NORDE) .LT. MIN) GO TO 3200
 3120 NSOL=NSOL+1
C  FIND OUT WHETHER THERE ARE IDENTICAL SOLUTIONS AMONG THE BEST ONES,
C  SKIP REFINEMENT + PRINT OUT IF THERE ARE.
      IF (I .EQ. 1) GO TO 3140
      A=0.
      K=I-1
      DO 3130 J=1,6
 3130 A=A+ABS(ROSTER(K,J)-ROSTER(I,J))
      IF (A .GT. FMINEQ) GO TO 3140
C  THE LATTICE IS NEARLY THE SAME AS THE PRECEDING ONE
      WRITE(IOUT ,9949) I,K
      GO TO 3170
 3140 DO 3150 J=1,10
 3150 CEL(J)= ROSTER(I,J)
      IF (NSOL .EQ. 1) WRITE(NSUMM,9970) (CEL(K),K=1,8)
      ZERTOT=ROSTER(I,11)
      CALL REFPAR(NSOL,ALL)
      IF (NSOL .EQ. 1) WRITE(NSUMM,9970) (CEL(K),K=1,8)
      DO 3160 J=1,10
 3160 ROSTER(I,J)=CEL(J)
      ROSTER(I,11)=ZERTOT
 3170 IF (NSOL .EQ. NSOLMX) GO TO 3205
 3200 CONTINUE
C  AFTER THIS REFINEMENT CYCLE, A NEW SORT IS MADE.
C  THE NEW CRITERION IS: (FIGURE OF MERIT)/ (21-LINES INDEXED)
C  ROSTER:1-6 CELL CONST., 7=LINES INDEXED, 8=M20, 9-BRAVTYP,
C          10=PEDIGREE, 11=ZEROSHIFT,  12=RANKING.
 3205 NSOL=NSOLMX
      IF (NR .LT. NSOLMX) NSOL=NR
      DO 3210 I=1,NSOL
 3210 ROSTER(I,12)=ROSTER(I,8)/(21.0-ROSTER(I,7) )
      DO 3250 I=1,NSOL
      AA=0.
      DO 3230 J=I,NSOL
         IF (ROSTER(J,12) .GT. AA) THEN
            AA=ROSTER(J,12)
            L=J
         END IF
 3230 CONTINUE
      DO 3240 N=1,12
      A=ROSTER(I,N)
      ROSTER(I,N)=ROSTER(L,N)
      ROSTER(L,N)=A
 3240 CONTINUE
 3250 CONTINUE
      CALL TIMER(8)
C  PRINT FINAL TABLE OF LATTICES
      WRITE(IOUT ,9954)  NAME,NSOL
      WRITE(NSUMM,9984) SNAME,NSOL
      DO 3260 I=1,NSOL
      TET=TWORAD*ROSTER(I,11)
      KKK=NINT( ROSTER(I,9) )
      WRITE(IOUT ,9955) ( ROSTER(I,N),N=1,8),  ROSTER(I,10),
     1   BRAVTP(KKK),TET
      WRITE(NSUMM,9983) ( ROSTER(I,N),N=1,8), BRAVTP(KKK)
 3260 CONTINUE
      CALL NTEST(NTST,9)
C-----------------------------------------------------------------------
C--PRINT THE VALUES OF THE PARAMETERS OF THE DIRECT LATTICE.
C-----------------------------------------------------------------------
      WRITE(IOUT ,9956)
      WRITE(NSUMM,9956)
      DO 3280 I=1,NSOL
      DO 3270 J=1,10
 3270 CEL(J)= ROSTER(I,J)
      CALL UNTCEL(WMOL,DOBS,VOL,1)
      WRITE(NSUMM,9988) (CEL(J),J=1,7)
 3280 CONTINUE
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  THE BEST SOLUTIONS ARE TESTED ON HIGHER SYMMETRIES,THAT MAY BE
C  CONCEALED IN THE Q-VALUES.
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      DO 3320  ISOL=1,NSOL
      DO 3310 J=1,10
 3310 CEL(J)=ROSTER(ISOL,J)
      CALL SYMTST
 3320 CONTINUE
      WRITE(IOUT ,9957)
      WRITE(IOUT ,9959)
      WRITE(NSUMM,9959)
      WRITE(IOUT ,9958) NAME
      CALL TIMER(9)
C  ---------------------------------------------------------------------
C  THE BEST SOLUTION IS NOW USED TO TRY AND INDEX ALL LINES ENTERED.
C-----------------------------------------------------------------------
      IF (ROSTER(1,7) .LT. 17.9) RETURN
      IF (ROSTER(1,8) .LT. 10.0) RETURN
      CALL SRTSYM
      IF ((SYMCON(1,3).GT.0.1) .AND. (SYMCON(1,4) .GT. 0.9*MAX))  THEN
         CALL SYMPRT
      ELSE
         ALL=.TRUE.
         DO 3400 I=1,10
 3400    CEL(I)=ROSTER(1,I)
         ZERTOT=ROSTER(1,11)
         WRITE(NSUMM,9970) (CEL(K),K=1,8)
         CALL REFPAR(1,ALL)
         WRITE(NSUMM,9970) (CEL(K),K=1,8)
         WRITE(NSUMM,9971) TWORAD*ZERTOT
         ROSTER(1,11)=ZERTOT
         WRITE(IOUT ,9956)
         WRITE(NSUMM,9956)
         CALL UNTCEL(WMOL,DOBS,VOL,1)
         WRITE(NSUMM,9988) (CEL(J),J=1,7)
         WRITE(NSUMM,'(/,1X,A70)' ) SNAME
      END IF
      CALL TIMER(9)
      NRRUN=2
      RETURN
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
 9905 FORMAT(/' LATTICE',I3,' SWITCHES BACK AND FORTH BETWEEN NORM3 ',
     * 'AND REFINE.' / ' POSSIBLY REFINE CHANGES THE ORDER OF THE ',
     * 'CELL CONSTANTS AND NORM3'/ ' SWITCHES THEM BACK.   THE CELL ',
     * 'IS ACCEPTED AS:' / 6F10.2 / 4F8.0 )
 9909 FORMAT(//,' LATTICE NR.',I3,'  WILL NOW BE REFINED AND',
     * ' NORMALISED',20(2H==)  )
 9910 FORMAT(1H ,I5,6F8.1,24X,F8.0,20H DISCARDED BY NORM3  )
 9911 FORMAT(1H ,I5,6F8.1,F8.0,16X,F8.0,23H IS THE SAME AS LATTICE,
     *  F6.0)
 9912 FORMAT(1H ,I5,6F8.1,4F8.0,25H NOT ENOUGH LINES INDEXED  )
 9913 FORMAT(1H ,I5,6F8.1,4F8.0,28H FIGURE OF MERIT IS TOO LOW.  )
 9914 FORMAT(1H ,I5,6F8.1,4F8.0, 20H LATTICE ACCEPTED.   )
 9915 FORMAT(///47H0***  NOTES  ***    THE SUBROUTINE ** THREED **,
     1       50HCOLLECTS TOO MANY LATTICES (BETTER TOO MANY THAN T,
     2       12HOO LITTLE).    /
     3       50H SOME OF THESE MUST BE DISCARDED BECAUSE THE LATTI,
     4       50HCE IS IMPOSSIBLE (E.G.CONTAINS NEGATIVE Q-VALUES),/
     5       50H OTHERS MUST BE DISCARDED BECAUSE THE ALLEGED SYMM,
     6       50HETRY REDUCES THE RECIPROCAL CELL EDGES BELOW THE  /
     7       50H MINIMUM ALLOWED.                                 )
 9916 FORMAT(50H     AFTER NORMALISING, SOME LATTICES TURN OUT TO ,
     9       50HBE THE SAME. ONLY ONE OF THESE IS RETAINED. THESE /
     A       50H LATTICES ARE INDICATED.                          /
     B       50H     FINALLY, THE PROGRAM TRIES TO INDEX THE PATTE,
     C       52HRN WITH THESE LATTICES AND REFINES THEIR PARAMETERS./
     D       50H IF A LATTICE DOES NOT INDEX ENOUGH LINES OR IF IT,
     E       51HS FIGURE OF MERIT IS BELOW ALL HOPE FOR IMPROVEMENT/
     F       50H THAT LATTICE IS DROPPED TOO.                       )
 9924 FORMAT(/,' NOT ONE ACCEPTABLE LATTICE HAS BEEN FOUND. ' )
 9925 FORMAT(50H NO LATTICES HAVE BEEN FOUND. TRY AGAIN WITH E.G. ,
     1       50HLARGER TOL3 (COL. 16-20).  THIS PROBLEM IS SKIPPED)
 9936 FORMAT(1H1,20X,A80 / 40(3H---)/
     *60H0               LATTICES REDUCED AND PUT INTO STANDARD FORM //
     *56X,24HLINES  FIGURE    BRAVAIS/
     *56H SERIAL   A       B       C        D       E       F     ,
     *34HINDXD  OF MERIT  LATTICE  PEDIGREE   )
 9937 FORMAT(1H ,I5,6F8.1, 2F8.0)
 9949 FORMAT(9H0SOLUTION,I3,35H IS NOT PRINTED, IT IS THE SAME AS ,
     2 9HSOLUTION ,I2)
 9950 FORMAT(1H1,20X,A80/ 40(3H---)  )
 9951 FORMAT(1H0,14X,47HTRIAL LATTICES AFTER INDEXING AND LS REFINEMENT
     *//14X,52HONLY THE FIRST 20 LINES ARE CONSIDERED FOR INDEXING  //
     *59X,24HLINES  FIGURE    BRAVAIS/
     *95H      A        B        C        D         E        F    INDEXE
     *D  OF MERIT  LATTICE  PEDIGREE   ,18HVOLUME  ZEROSHIFT  )
 9952 FORMAT(1H )
 9953 FORMAT(1H ,6F9.1,F9.0,F9.1,8X,A1,F9.0,F8.1,F10.4 )
 9954 FORMAT(1H1,20X,A80/ 40(3H---) // 30X, 4HTHE ,I2,
     1        25H MOST PROBABLE SOLUTIONS //// 58X,
     2 34HLINES  FIGURE OF           BRAVAIS/
     3 60H    Q(A)     Q(B)     Q(C)      Q(D)     Q(E)     Q(F)   IND,
     4 44HEXED   MERIT   PEDIGREE  LATTICE  ZEROSHIFT  )
 9955 FORMAT(1H ,6F9.2,F9.0,F9.1,F9.0,8X,A1,F10.4)
 9956 FORMAT(//1H ,20X,38HTHE DIRECT CONSTANTS OF THESE LATTICES//
     * 60H     A        B        C       ALFA     BETA     GAMMA      ,
     * 6HVOLUME)
 9957 FORMAT(1H0///40X,24H ****   ATTENTION   ****//
     160H 1. ANY *SOLUTION* WITH A FIGURE OF MERIT LESS THAN 4.0 IS W,
     260HORTHLESS AND SHOULD BE REJECTED RIGHT AWAY.                 //
     360H 2. ANY *SOLUTION*THAT LEAVES MORE THAN TWO VERY WEAK LINES ,
     460HUNEXPLAINED  IS WORTHLESS.   HOWEVER, IF THE FIGURE OF MERIT/
     560H    IS GREATER THAN 10.0 IT MIGHT BE WORTHWHILE TO EXAMINE  ,
     660HTHE INPUT DATA  AND THE *SOLUTION* MORE CLOSELY.            //
     760H 3. EVEN *SOLUTIONS* THAT INDEX ALL LINES WITH A FIGURE OF M,
     860HERIT GREATER THAN 10.0 SHOULD NOT BE ACCEPTED UNCRITICALLY  /
     933H    WITHOUT FURTHER INVESTIGATION//)
 9958 FORMAT(1H0,A80)
 9959 FORMAT(// 1X,23(3H***) / 2H *,67X,1H* /,
     1 ' * THIS PROGRAM GIVES A NUMBER OF SUGGESTIONS THAT MAY HELP',
     2 ' YOU TO   *' /' * FIND THE UNIT CELL THAT EXPLAINS YOUR',
     3 ' EXPERIMENTAL DATA. HOWEVER  *'/2H *,67X,'*'/
     4  2H *,5X,19(3HWWW),6H     * /
     4  ,8H *     W,55X,7HW     */ 8H *     W,
     5  '  IT IS ENTIRELY THE USERS RESPONSIBILITY TO DECIDE    W     *'
     6 ,/ 8H *     W,'  WHETHER ANY OF THE SUGGESTED UNIT CELLS IS THE',
     7  7X,'W     *' / ' *     W   CORRECT CELL. ',38X,'W     *' /
     8  8H *     W, 55X, 7HW     * / 7H *      ,
     9 19(3HWWW), 6H     * / 2H *,67X,1H*/1H ,23(3H***) )
 9960 FORMAT(1H1,20X,A80 / 40(3H---)  //
     160H POSSIBLE LATTICES BASED ON THE ABOVE COMBINATION OF ZONES  //
     258H SERIAL    A       B       C        D       E       F       ,
     315HHITS  PEDIGREE   )
 9963 FORMAT(7H0NOTES //
     160H  1. *LINES INDEXED* REFERS TO THE NUMBER OF LINES FROM THE ,
     260HFIRST 20 OBSERVED LINES THAT HAVE BEEN ACCEPTED AS INDEXED  /
     360H     BY THIS LATTICE, UP TO A MAXIMUM OF 20, WHICH WOULD REP,
     460HRESENT COMPLETE SUCCESS.                                    //
     560H  2. *FIGURE OF MERIT* IS DEFINED AS QOBS(20)/(2*MEANDIFF*NC,
     660HALC) WHERE DIFFERENCES ARE TAKEN FOR INDEXED LINES ONLY     /
     760H     AND *NCALC* IS THE NUMBER OF LINES GENERATED UP TO Q=1.,
     860H003*Q(20),REGARDLESS OF WHETHER OR NOT THEY CONTRIBUTE TO   /
     960H     THE INDEXINGS, BUT EXCLUDING SYSTEMATIC ABSENCES DUE TO,
     *27H THE BRAVAIS LATTICE TYPE. /
     A60H     IT IS CLOSELY RELATED TO  M20 ,DE WOLFF(J.APPL.CRYST.19,
     B60H68,1972), ALLOWING FOR LESS THAN 20 SUCCESSFUL INDEXINGS.   )
 9964 FORMAT(4H0THE, I3,
     *       50H BEST SOLUTIONS ARE NOW PRINTED MORE EXTENSIVELY.   )
 9965 FORMAT(50H0THE CHANCES FOR SOME LATTICES ARE ENHANCED. ONLY ,
     *       50HTHOSE ARE PRINTED OUT.                            )
 9966 FORMAT(50H0 THE PRINTING OF SOME  LATTICES IS SUPPRESSED    )
 9967 FORMAT(50H0FOR THE LATTICES IN THE CRYSTAL SYSTEMS THAT ARE ,
     *       50HTREATED PREFERENTIALLY, THE TOLERANCE HAS BEEN    /
     2       54H DOUBLED AND TWO ROUNDS OF LEAST SQUARES ARE EXECUTED.,
     3       50H AFTERWARDS, THESE SOLUTIONS ARE SORTED WITH      /
     4       50H THE OTHER SOLUTIONS ON LINES INDEXED AND FIGURE  ,
     5       50HOF MERIT.                                         /
     6       50H IF YOUR PREFERRED SYSTEM DOES NOT COME OUT ON TOP,
     7       54H THERE MIGHT BE SOMETHING AMISS WITH YOUR ASSUMPTIONS.)
 9970 FORMAT(//'    SOLUTION NR. 1  '/ 1X,6F9.2,F6.0,F6.1  )
 9971 FORMAT(' ZEROSHIFT=',F9.4 / )
 9980 FORMAT(////1H ,A70/ 35(2H--)  //
     1       1H ,14X,47HTRIAL LATTICES AFTER INDEXING AND LS REFINEMENT
     2//14X,52HONLY THE FIRST 20 LINES ARE CONSIDERED FOR INDEXING  //
     3 55X,'LINES FIGUR LAT' /
     4 '      A        B        C        D         E        F  INDXD',
     5 ' MERIT TYP'  )
 9983 FORMAT(1H ,6F9.1,F6.0,F6.1,2X,A1)
 9984 FORMAT(///1H0,A70/ 35(2H--) //
     1 20X,'THE ',I2, 25H MOST PROBABLE SOLUTIONS ////
     2 55X,'LINES FIGUR LAT' /
     3 '    Q(A)     Q(B)     Q(C)     Q(D)      Q(E)     Q(F) INDXD',
     4 ' MERIT TYP'  )
 9988 FORMAT(1H ,6F9.4,F12.2)
 9990 FORMAT(/52H NOT ONE ACCEPTABLE LATTICE HAS BEEN FOUND FOR THIS
     2     , 52H PROBLEM. USUALLY THIS MEANS THAT YOUR DATA ARE NOT
     3     / 50H GOOD ENOUGH. YOU MIGHT ALSO TRY OTHER PARAMETERS.  /
     4       50H0THIS PROBLEM IS SKIPPED.                           )
      END
      SUBROUTINE ARRAY(MODE,I,J,N,M,S,D)
C
C  COPIED FROM  THE I.B.M.  SCIENTIFIC SUBROUTINE PACKAGE.
C  TO BE USED IN COMBINATION WITH THE SUBROUTINE  MINV (MATRIX INVERSION
C
      DIMENSION S(64),D(64)
      NI=N-I
      IF(MODE .GT. 1) GO TO 20
      IJ=I*J+1
      NM=N*J+1
      DO 10 K=1,J
      NM=NM-NI
      DO 10 L=1,I
      IJ=IJ-1
      NM=NM-1
      D(NM)=S(IJ)
   10 CONTINUE
      GO TO 40
   20 IJ=0
      NM=0
      DO 30 K=1,J
      DO 25 L=1,I
      IJ=IJ+1
      NM=NM+1
      S(IJ)=D(NM)
   25 CONTINUE
      NM=NM+NI
   30 CONTINUE
   40 RETURN
      END
      SUBROUTINE BIBLIO
C  THE SUBROUTINE GIVES A BIBLIOGRAPHY ON INDEXING METHODS AND
C  DIRECTLY RELATED SUBJECTS. DO NOT EXPECT IT TO BE COMPLETE.
C
C  ********************************************************************
C  *  THE AUTHOR WILL BE VERY GRATEFUL FOR EVERY ADDITIONAL RELEVANT  *
C  *  REFERENCE. PLEASE SEND TO:                                      *
C  *  J.W. VISSER/ C.O. T.P.D./P.O.BOX 155/2600AD DELFT/NETHERLANDS.  *
C  ********************************************************************
C
C
C  WHY THIS PROGRAM WORKS AND HOW:
C---------------------------------
C  P.M. DE WOLFF, ACTA CRYST. 10 (1957) 590-595:
C    ON THE DETERMINATION OF UNIT CELL DIMENSIONS FROM POWDER
C    DIFFRACTION PATTERNS.
C  P.M. DE WOLFF, ACTA CRYST. 11 (1958) 664-665:
C    DETECTION OF SIMULTANEOUS ZONE RELATIONS AMONG POWDER DIFFR.LINES
C  P.M. DE WOLFF, ACTA CRYST. 14 (1961) 579-582:
C    RELIABILITY OF UNIT CELLS DERIVED FROM POWDER DIFFRACTION PATTERNS.
C  P.M. DE WOLFF, ADVANCES IN X-RAY ANALYSIS, 6 (1962) 1-17:
C**  INDEXING OF POWDER DIFFRACTION PATTERNS.
C  P.M. DE WOLFF, J. APPL. CRYST. 1 (1968) 108-113:
C    A SIMPLIFIED CRITERION FOR THE RELIABILITY OF A POWDER PATTERN
C    INDEXING.
C  J.W. VISSER, J. APPL. CRYST. 2 (1969) 89-95:
C    A FULLY AUTOMATIC PROGRAM FOR FINDING THE UNIT CELL FROM POWDER DAT
C                       -----------------
C
C  OTHER WELL KNOWN METHODS:
C  -------------------------
C  HESSE,R.   ACTA CRYST. 1 (1948) 200
C    INDEXING POWDER PHOTOGRAPHS OF TETRAGONAL,HEXAGONAL AND
C    ORTHORHOMBIC CRYSTALS.
C  LIPSON,H.   ACTA CRYST.  2 (1949), 43
C    INDEXING POWDER PHOTOGRAPHS OF ORTHORHOMBIC CRYSTALS
C-TRIAL AND ERROR METHODS:
C  WERNER,P.-E.  Z. KRISTALLOGR. 120 (1964) 375-387
C    TRIAL AND ERROR COMPUTER METHODS FOR THE INDEXING OF UNKNOWN
C    POWDER PATTERNS.
C  WERNER,P-E.+ERIKSSON,L+WESTDAHL,M  J.APPL.CRYST.18 (1985) 367-370
C    TREOR, A SEMI-EXHAUSTIVE TRIAL-AND-ERROR POWDER INDEXING PROGRAM
C    FOR ALL SYMMETRIES.
C  TAUPIN,D.   J.APPL. CRYST. 1 (1968) 178-181
C    UNE METHODE GENERALE POUR L'INDEXATION DES DIAGRAMMES DE POUDRES.
C  TAUPIN,D.   J.APPL. CRYST. 6 (1973) 380-385
C    A POWDER-DIAGRAM AUTOMATIC-INDEXING ROUTINE.
C  GOEBEL,J.B. AND WILSON,A.S. (1965) BATELLE-NORTHWEST REPORT BNWL-22
C    INDEX, A COMPUTER PROGRAM FOR INDEXING X-RAY DIFFRACTION POWDER
C    PATTERNS.
C  KOHLBECK,F. AND HOERL,E.M.  J. APPL. CRYST. 9 (1976) 28-33
C    INDEXING PROGRAM FOR POWDER PATTERNS, ESP. TRICL,MONOCL ETC.
C  KOHLBECK,F. AND HOERL,E.M.  J. APPL. CRYST. 11 (1978) 60-61
C    TRIAL AND ERROR PROGRAM FOR POWDER PATTERNS OF MONOCLINIC SUBSTANCE
C-DEDUCTIVE METHODS (ITO- TYPE):
C  HAENDLER,H.M. AND COONEY,W.A.  ACTA CRYST. 16 (1963) 1243-1248
C    COMPUTER DETERMINATION OF UNIT CELL FROM POWDER DIFFRACTION DATA.
C  ISHIDA,T. AND WATANABE,Y.  J.PHYS.SOC.JAPAN 23 (1967) 556
C  ISHIDA,T. AND WATANABE,Y.  J. APPL. CRYST. 4 (1971) 311-316
C    ANALYSIS OF POWDER DIFFRACTION PATTERNS OF MONOCLINIC AND
C    TRICLINIC CRYSTALS.
C  ISHIDA,T. AND WATANABE,Y.  Z. KRIST. 160 (1982) 19-32
C    A CRITERION METHOD FOR INDEXING UNKNOWN POWDER DIFFRACTION PATTERNS
C-TRIAL AND ERROR IN PARAMETER SPACE:
C  LOUER,D. AND LOUER,M. J. APPL. CRYST. 5 (1972) 271-275
C    METHODE D'ESSAIS ET ERREURS POUR L'INDEXATION AUTOMATIQUE DES
C    DIAGRAMMES DE POUDRE.  (METHOD OF SUCCESIVE DICHOTOMY)
C  LOUER,D  AND VARGAS,R   J.APPL.CRYST.  15 (1982) 542-545
C    INDEXATION AUTOMATIQUE DES DIAGRAMMES DE POUDRE PAR
C    DICHOTOMIES SUCCESIVES.
C-COMBINATIONS OF METHODS:
C  SHIRLEY,R AND LOUER,D   ACTA CRYST. A 34 (1978) S382 (ABSTRACT):
C    NEW POWDER INDEXING PROGRAMS FOR ANY SYMMETRY WHICH COMBINE
C    GRID-SEARCH WITH SUCCESSIVE DICHOTOMY.
C  SHIRLEY,R. IN 'CRYSTALLOGRAPHIC COMPUTING' DELFT UNIVERSITY PRESS 197
C    INDEXING POWDER DIAGRAMS. P 221-234.
C
C
C  THE RELIABILITY OF THE UNIT CELL OBTAINED:
C  ------------------------------------------
C  WOLFF,P.M. DE,   J. APPL. CRYST. 1 (1968) 108-113:
C    A SIMPLIFIED CRITERION FOR THE RELIABILITY OF A POWDER PATTERN
C    INDEXING.
C  WOLFF,P.M. DE,   J. APPL. CRYST. 5 (1972) 243
C    THE DEFINITION OF THE INDEXING FIGURE OF MERIT M20.
C  WERNER,P.-E.   J. APPL. CRYST. 9 (1976) 216-219:
C   ON THE DETERMINATION OF UNIT CELL DIMENSIONS FROM INACCURATE DATA.
C  MIGHELL,A.D. AND STALICK,J.K.  ACCURACY IN POWDER DIFFRACTION 393-403
C    THE RELIABILITY OF POWDER INDEXING PROCEDURES.
C
C  REVIEW PAPERS:
C  --------------
C  P.M. DE WOLFF, ADVANCES IN X-RAY ANALYSIS, 6 (1962) 1-17:
C**  INDEXING OF POWDER DIFFRACTION PATTERNS.
C  SHIRLEY,R. IN ACCURACY IN POWDER DIFFRACTION  (1979) 361-382.
C** DATA ACCURACY FOR POWDER INDEXING.  (PAPER ON THE INDEXING PROBLEM)
C  SHIRLEY,R. ACTA CRYST. A 31 (1975) S197 (ABSTRACT):
C    RECENT ADVANCES IN DETERMINING UNKNOWN UNIT CELLS FROM POWDER
C    DIFFRACTION DATA.
C  SHIRLEY,R. IN 'CRYSTALLOGRAPHIC COMPUTING' DELFT UNIVERSITY PRESS 197
C    INDEXING POWDER DIAGRAMS. P 221-234.
C
C
C  LESS OFTEN USED METHODS AND RELATED PUBLICATIONS
C  ------------------------------------------------
C--GRAPHIC METHODS
C  ZSOLDOS,L.  ACTA CRYST. 11 (1958), 835-839  (A GRAPHICAL METHOD)
C    A GENERAL METHOD OF INDEXING PHOTOGRAPHS OF LOW-SYMMETRY CRYSTALS.
C  ARTHUR JR,P.  Z. KRISTALLOGR. 120 (1964) 415-426.
C    AN APPROACH TO THE INDEXING OF X-RAY POWDER DIFFRACTION PATTERNS.
C--DIOPHANTINE EQUATIONS (USING THE FACT THAT MILLER INDICES ARE INTEGER
C  STOSICK,A.J.  ACTA CRYST. 2 (1949) 271-277
C    A METHOD FOR INDEXING POWDER PHOTOGRAPHS, USING LINEAR DIOPHANTINE
C    EQUATIONS, AND SOME TESTS FOR CRYSTAL CLASSES.
C  VAND,V. AND JOHNSON JR,G.G.  ACTA CRYST. A24 (1968) 543-546
C    INDEXING OF X-RAY POWDER PATTERNS.PART I.
C    THE THEORY OF THE TRICLINIC CASE.
C--DEDUCTIVE METHODS, ITO-TYPE:
C  HOMES,G.A. AND GOUZOU,J.  REV. DE METALL. 51 (1954) 749-757
C    RECHERCHE D'UNE METHODE NOUVELLE DE DECHIFFREMENT DES DIAGRAMMES
C    DE DEBYE-SCHERRER.
C  MCMASTERS,O.D. & LARSEN,W.L.  IS-839   MARCH 1, 1964.
C    DETERMINATION OF THE CRYSTALLOGRAPHIC LATTICE TYPE AND CELL
C    CONSTANTS FROM X-RAY POWDER PATTERN DATA:  A COMPUTER PROGRAM.
C    AMES LABORATORY AT IOWA STATE UNIVERSITY.
C  PROST,M. & MENTZEN,B.  C.R.ACAD.SC. PARIS,(SER C) 274 (1972) 1123-112
C    SUR LE DEPOUILLEMENT AUTOMATIQUE DES DIAGRAMMES DE DIFFRACTION X
C    OBTENUS PAR LA METHODE DES POUDRES.
C--ON LIPSON METHODS:
C  DAVIES,P.T. ACTA CRYST. 7 (1954) 623
C    AN IMPROVED METHOD OF INDEXING POWDER DIFFRACTION PATTERNS OF
C    ORTHORHOMBIC CRYSTALS.
C  ZSOLDOS,L.  ACTA CRYST. 16 (1963), 572-573
C    ON THE MOST PROBABLE DIFFERENCES OCCURRING IN THE LIPSON-HESSE
C    DIFFERENCE METHOD FOR INDEXING POWDER PHOTOGRAPHS.
C--ON MONOCLINIC PATTERNS:
C  ZACHARIASEN,W.H.  ACTA CRYST. 16 (1963) 784-788
C    INTERPRETATION OF MONOCLINIC POWDER X-RAY DIFFRACTION PATTERNS.
C  SMITH,G.S. AND KAHARA,E.  J. APPL. CRYST. 8 (1975) 681-683
C    AUTOMATED COMPUTER INDEXING OF POWDER PATTERNS: THE MONOCLINIC CASE
C  GUO CHANG-LIN & MA LI-TAI, ACTA PHYSICA SINICA 32 (1983) 1-14
C    AN ANALYTICAL METHOD FOR INDEXING X-RAY POWDER PATTERNS
C    OF MONOCLIONIC SUBSTANCES. (IN CHINESE, ENGL. ABSTRACT)
C--ON HIGH-SYMMETRY LATTICES:
C  WU XUEQUAN AND ZUNG-PING CHANG   J.APPL. CRYST. 17 (1984) 395-399
C    AN ANALYTICAL METHOD FOR INDEXING POWDER DIFFRACTION PATTERNS
C    OF HIGHER-SYMMETRY SUBSTANCES.
C--RELATED AND UNCLASSIFIED PAPERS:
C  VAND,V.     ACTA CRYST.  1 (1948), 109-115 AND 290-291.
C    INDEXING METHOD OF POWDER PHOTOGRAPHS OF LONG-SPACING COMPOUNDS.
C  HAUCK,J.   Z. KRISTALLOGR. 149 (1979)  188-190
C    EIN EINFACHES HILFSMITTEL ZUR INDIZIERUNG VON PULVERAUFNAHMEN.
C  SMITH,G.S.   J. APPL. CRYST. 9 (1976) 424-428
C    ESTIMATING UNIT CELL VOLUMES FROM POWDER DIFFRACTION DATA:
C    THE TRICLINIC CASE.
C  SMITH,G.S.   J. APPL. CRYST.10 (1977) 252-255
C    ESTIMATING THE UNIT CELL VOLUME FROM ONE LINE IN A POWDER
C    DIFFRACTION PATTERN: THE TRICLINIC CASE.
C  FERRO,R.   ATTI D. ACAD. NAZ. LINCEI  15 (1953) 285-289
C    CRISTALLOGRAFIA DIFFERENZIALE DELLE POLVERI.
C  GUO CHANG-LIN & HUANG YUE-HONG, ACTA PHYSICA SINICA 31 (1982) 972-6
C    AN ITERATIVE CORRECTION METHOD FOR INDEXING THE X-RAY POWDER
C    DIFFRACTION PATTERNS.
C  SERYKH,V.P.   KRISTALLOGRAFIYA 27 (1982) 994(SOV.PH.CR. 27  596)
C    USE OF EXTINCTIONS IN PROGRAMS FOR INDEXING POWDER PATTERNS.
C  SERYKH,V.P.  KRISTALLOGRAFIYA 20 (1975) 1170-1174
C    ON UNAMBIGUOUS INDEXING OF X-RAY POWDER PHOTOGRAPHS OF MONOCLINIC
C    AND RHOMBIC CRYSTALS.(SOV. PHYS. CRYST. 20  710-712)
C  SERYKH,V.P.  KRISTALLOGRAFIYA 24 (1979) 1041-1042
C    RELIABILITY OF INDEXING OF X-RAY DIFFRACTION POWDER PATTERNS
C    (SOV. PHYS. CRYST. 24 (1979) 595-596  )
C  SERYKH,V.P.  TITOV,YU.G.  MATYUSHENKO,N.N.  KRIST.GRAFIYA 16 226-228
C    THE RANGES OF THE INDICES IN THE QUADRATIC FORMULA FOR
C    POLYCRISTALLINE AGGREGATES.   (SOV. PHYS. CRYST. 16 (1971) 181-182
C  PASZKOWICZ,W.   ACTA CRYST A40, C367 (1984):
C    INDEXING OF ORTHORHOMBIC POWDER PATTERNS WITH THE OPTIMIZATION METH
C                       ---------------------
C
C  OLDER PUBLICATIONS:
C  ------------------
C  RUNGE,C.   PHYS. Z. 18 (1917) 509-515
C    DIE BESTIMMUNG EINES KRISTALLSYSTEMS DURCH ROENTGENSTRAHLEN.
C  JOHNSEN,A. AND TOEPLITZ,O., PHYS. Z. 19 (1918) 47-55
C    UEBER DIE MATHEMATISCHE AUSWERTUNG DER DEBYE-SCHERRERSCHEN
C    ROENTGEN-SPEKTROGRAMME.
C  ITO,T.  NATURE (LONDON) 164 (1949) 755-756:
C     A GENERAL POWDER X-RAY PHOTOGRAPHY
C  ITO,T.  X-RAY STUDIES ON POLYMORPHISM   TOKIO, MARUZEN.(1960)
C--GRAPHICAL  METHODS:
C  HULL,A.W. AND DAVEY,W.P.  PHYS. REV. 17 (1921) SER. 2, 549-570
C  BJURSTROEM,T.  Z. PHYS. 69 (1931)  346-355
C  BUNN,C.W.   CHEMICAL CRYSTALLOGRAPHY (1945) OXFORD,UNIVERSITY PRESS.
C  NOVAK,C.  CZECHOSLOV. J. PHYS. 4 (1954) 496
C                       --------------------
C
C
C=======================================================================
C 'ADVANCES IN X-RAY ANALYSIS' ARE THE PROCEEDINGS OF THE ANNUAL
C    DENVER X-RAY CONFERENCES.
C 'ACCURACY IN POWDER DIFFRACTION'  IS THE PROCEEDINGS OF A SYMPOSIUM
C    WITH THAT TITLE, HELD AT THE NBS IN GAITHERSBURG IN 1979. IT IS
C    ISSUED AS  NAT. BUR. OF STANDARDS (USA) SPECIAL PUBLICATION 567.
C=======================================================================
C** THE PAPERS BY DE WOLFF AND SHIRLEY GIVE A GOOD INTRODUCTION TO
C   THE SUBJECT WITHOUT BECOMING TOO TECHNICAL.
C                        ----------------
C
      COMMON /LINES / IDOC,INP,IOUT,MAX,OBS(40),CEL(10)
      WRITE(IOUT,90)
   90 FORMAT(1H0,42(2H==)/
     1 ' ==   A RESTRICTED BIBLIOGRAPHY IS GIVEN IN THE TEXT OF ',
     2 'THE SUBROUTINE  *BIBLIO*   ==' / 1H ,42(2H==)  //  )
      RETURN
      END
      SUBROUTINE     CRITER(K1,L1,CENTER,CRIT,NO,NC)
C  THIS SUBROUTINE CALCULATES THE PROBABILITY THAT A ZONE IS FOUND BY
C  PURE CHANCE. A LINE WITH ITS HIGHER ORDERS IS COUNTED AS ONE
C  OBSERVATION.
C  INPUT PARAMETERS:   K1 IS THE STEPSIZE FOR K
C                      L1 IS THE STEPSIZE FOR L (H)
C                      CENTER OBVIOUSLY GOVERNS THE TEST ON CENTERING
C                      PROB IS THE PROBABILTY OF FINDING A LINE BY CHANC
C  OUTPUT PARAMETER:   CRIT IS THE INVERSE OF THE PROBABILITY THAT THIS
C                      ZONE IS FOUND BY PURE CHANCE
C
C  EVAL IS
C             ZERO ON THE POSITIONS WHERE THE CALCULATED Q WAS TOO LARGE
C
C             NEGATIVE WHEN THE Q-VALUE WAS ONLY CALCULATED BUT NOT
C             OBSERVED,  AND
C
C             POSITIVE WHEN THE CALCULATED Q WAS ALSO OBSERVED.
C
C  THE VALUE OF EVAL IS A SORT OF PROBABILITY THAT A CALCULATED LINE
C  HITS AN OBSERVED LINE BY CHANCE.
C
C
      INTEGER  H,HG
      DIMENSION EVA(-8:8,0:8)
      LOGICAL CALC,PRES,CENTER,RECTAN
      COMMON /EVALN / NORDER,RECTAN,PROB(40),EVAL(-8:8,0:8),
     1                UPBNDR(40)
      ZERO=1.0E-30
      NCENTR=1
      IF ( CENTER) NCENTR=2*K1
      DO 12 I=-8,8
      DO 10 J=0,8
   10 EVA(I,J)=EVAL(I,J)
   12 CONTINUE
      KG=NORDER*K1
      HG=NORDER*L1
      NC=0
      NO=0
      CRIT=1.
      LSTEP=L1
      IF (CENTER) LSTEP=NCENTR
      DO 110 K=0,KG, K1
         LMIN=0
         IF (CENTER) LMIN=MOD(K,NCENTR)
         IF (K .EQ. 0) LMIN=LSTEP
         DO 100 L=LMIN,HG, LSTEP
         H=L
   30    IF (ABS(EVA(H,K)) .LT. ZERO) GO TO 100
         PRES=.FALSE.
         DO 90 N=1,8
            NH=N*H
            NK=N*K
            IF (IABS(NH).GT.HG .OR. NK.GT.KG) GO TO 95
            IF (PRES) GO TO 85
            IF (CENTER .AND. (MOD((NH+NK),NCENTR) .NE. 0) ) GO TO 90
            IF (EVA(NH,NK) .GT. ZERO) THEN
               CRIT=CRIT*EVA(NH,NK)
               PRES=.TRUE.
            END IF
   85       EVA(NH,NK)=0.
   90    CONTINUE
   95    IF (PRES) NO=NO+1
         NC=NC+1
         IF (RECTAN) GO TO 100
         IF (H .LE. 0) GO TO 100
         H=-L
         GO TO 30
  100    CONTINUE
  110 CONTINUE
      MIN=3
      IF (RECTAN) MIN=2
      NO=NO-MIN
      NC=NC-MIN
C  WE REQUEST  THAT THE NUMBER OF OBSERVED LINES IS AT LEAST
C  25 PERCENT OF THE NUMBER OF CALCULATED LINES.
      IF (4*NO .GE. NC) THEN
         J=NO
         IF (2*NO .GT. NC) J=NC-NO
         IF (J .EQ. 0) GO TO 150
         DO 120 II=1,J
            I=II-1
            CRIT=CRIT*FLOAT(NC-I)/FLOAT(II)
  120    CONTINUE
      ELSE
         CRIT=100.
      END IF
  150 CRIT=1.0/CRIT
      IF (CRIT .GT. 1.0E+10) CRIT=9.999E+9
      RETURN
      END
      SUBROUTINE ECHO
C-----------------------------------------------------------------------
C  THE PURPOSE OF THIS SUBROUTINE IS TO PRINT THE CARD IMAGES OF THE
C  INPUT 'CARDS' ON A SEPARATE PAGE.
C  THIS IS VERY USEFUL FOR TEST PURPOSES AND FOR DOCUMENTATION.
C
C  THE INPUT DATA ARE READ AS CHARACTERS FROM THE 'INP' UNIT AND
C  WRITTEN ON THE *DOCUMENTATION FILE* (4) (IDOC=4).
C  THE OTHER SUBROUTINES READ FROM THE 'INTERNAL FILE' *CARD*
C
C  ECHO ALSO TESTS FOR THE END OF THE DATA. ('END' IN THE FIRST 4 COLS)
C-----------------------------------------------------------------------
      CHARACTER NAME*80,CARD*80,INTSY*2
      COMMON /LINES / IDOC,INP,IOUT,MAX,OBS(40),CEL(10)
      COMMON /CHARCM/ NAME,CARD,INTSY(50)
      DATA NCRD/0/
      NCRD=NCRD+1
      IF (NCRD .EQ. 1) WRITE(IDOC,9900)
      READ(INP,9901,IOSTAT=IOS)  CARD
      IF (IOS .EQ. 0) THEN
         WRITE(IDOC ,9902) NCRD, CARD
         I=INDEX(CARD, 'END' )
         IF ( (I .EQ. 1) .OR. (I .EQ. 2) ) THEN
            WRITE(IOUT,9998)
            STOP
         END IF
      ELSE  IF (IOS .LT. 0 ) THEN
         WRITE(IOUT,9995)
         STOP
      ELSE
         WRITE(IOUT,9996)
         STOP
      END IF
      RETURN
 9900 FORMAT(48H ON THIS PAGE THE CARD IMAGES OF THE INPUT CARDS ,
     1 14H ARE PRINTED.  //  20H  NR     CONTENTS       //
     2 7X,2H 0,8X,2H10,8X,2H20,8X,2H30,8X,2H40,8X,2H50,8X,2H60,
     3 8X,2H70,8X,2H80/ 8X,8(10HI....|....),1HI)
 9901 FORMAT(A80)
 9902 FORMAT(1H ,I3,5X,A80)
 9995 FORMAT('0UNEXPECTED END OF INPUT, PROGRAM STOPS')
 9996 FORMAT('0ERROR IN INPUT, PROGRAM STOPS.')
 9998 FORMAT('0END OF INPUT,  NORMAL END OF PROGRAM')
      END

